/*
 * dryer_station.c
 *
 * Created: 22.11.2017 16:12:58
 * Author: Artem
 */

#include <mega8.h>
#include <delay.h>



#define relay_on PORTD |= (1<<PORTD5)
#define relay_off PORTD &= ~(1<<PORTD5)
#define power_on !PINB.0
#define power_off PINB.0
#define triac_on PORTB |= (1<<PORTB1)
#define triac_off PORTB &= ~(1<<PORTB1)
#define reed_switch_on PIND.7
#define reed_switch_off !PIND.7
#define led_red_on PORTC |= (1<<PORTC2)
#define led_red_off PORTC &= ~(1<<PORTC2)
#define led_green_on PORTC |= (1<<PORTC1)
#define led_green_off PORTC &= ~(1<<PORTC1)
#define buzzer_on PORTD |= (1<<PORTD6)
#define buzzer_off PORTD &= ~(1<<PORTD6)






#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)
#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)

// USART Receiver buffer
#define RX_BUFFER_SIZE 5
unsigned long int rx_buffer[RX_BUFFER_SIZE];    //5
unsigned char rx_wr_index;
char read_enable = 0;
volatile char parameters_out = 0;
unsigned char rx_counter;
char rx_buffer_overflow;


// Standard Input/Output functions
#include <stdio.h>


           



// Declare your global variables here
    volatile unsigned char flag_phase;
    volatile unsigned char flag_100hz;
     volatile unsigned int temper;
             unsigned char i;     //  
     volatile unsigned int set_temper;        
volatile unsigned long int set_temper_adc_aver;
     volatile unsigned int set_temper_aver;
     volatile unsigned int last_set_temper_aver;
               float const coefLPF = 0.5;
           
       volatile signed int error;
           signed long int integral;
    
                     float Kp=1.2;      //0.15
   
                     float Ki=0.05;    // 0.0001
   
                     float Kd=0.5;       //1.5
  
       volatile signed int control_action;
                signed int last_error;
       volatile signed int sp;
volatile unsigned int bias;       
volatile unsigned long int set_flow_aver;
     volatile unsigned int set_flow;
     volatile unsigned int flow;
     volatile unsigned int last_flow; 
     volatile unsigned int flow_min;
              unsigned int flow_max;
              unsigned int temper_min;
              unsigned int temper_max;  
             unsigned char flag_pid_on;
             unsigned char buzzer_flag = 2;
             unsigned char buzzer_time = 0;
             unsigned char flag_flow_adj;
     volatile unsigned int reed_switch_time = 0; 
     
    volatile unsigned char led_pwm_off;
    volatile unsigned char led_pwm_on;
    volatile unsigned char led_pwm_flag;
    volatile unsigned char sleep_on;
    volatile unsigned char standby_on;  
    volatile unsigned char NewState;
    volatile unsigned char OldState;        
    volatile unsigned char flag_led_poweroff;         
    volatile unsigned char flag_led_poweron;
    
    
    
    
              
              //EEPROM
unsigned int eeprom eeflow_min;
unsigned int eeprom eeflow_max;
unsigned int eeprom eetemper_min;
unsigned int eeprom eetemper_max;
unsigned char eeprom eeflag_primary_values;
            
 
//    UART
void send_Uart(unsigned char c)//    
   {
   while(!(UCSRA&(1<<UDRE)))    //  ,   
    {}
    UDR = c;
   }

 void send_int_Uart(unsigned int c)//       0000  9999
  {
  unsigned char temp;                           //=2013
  c=c%10000;                                    //  2013%10000    0
  temp=c/100;                                   // 2013/100=  20
  //send_Uart(temp/10+'0');                       //  20/10 = 2 +'0'
  send_Uart(temp%10+'0');                       // 20%10 = 0 +'0'
  temp=c%100;;                                  // 2013%100 = 13
  send_Uart(temp/10+'0');                       // 13/10 = 1+'0'
  send_Uart(temp%10+'0');                       // 13%10 = 3+'0'
  } 

void send_Uart_str(unsigned char *s)//	 
  {
   while (*s != 0) send_Uart(*s++);
  }


            
             
             
             
void main(void)
{

//   
if(eeflag_primary_values == 255)
 {
 eeflow_min = 100;              
 eeflow_max = 255;                  
 eetemper_min = 50;                
 eetemper_max = 450;          
 eeflag_primary_values = 0;
 } 




//   eeprom
flow_min = eeflow_min;
flow_max = eeflow_max;
temper_min = eetemper_min;
temper_max = eetemper_max;  




// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=Out Bit2=In Bit1=In Bit0=In 
DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (1<<DDB3) | (0<<DDB2) | (1<<DDB1) | (0<<DDB0);
// State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=0 Bit2=T Bit1=T Bit0=T 
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (1<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (1<<DDC2) | (1<<DDC1) | (1<<DDC0);
// State: Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

// Port D initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRD=(0<<DDD7) | (1<<DDD6) | (1<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
// State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTD=(1<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (1<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);



// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Normal top=0xFFFF
// OC1A output: Disconnected
// OC1B output: Disconnected
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer Period: 0,51213 ms
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10);
TCNT1H=0xEF;
TCNT1L=0xFF;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Fast PWM top=0xFF
// OC2 output: Non-Inverted PWM
// Timer Period: 8,192 ms
// Output Pulse(s):
// OC2 Period: 8,192 ms Width: 0 us
ASSR=0<<AS2;
TCCR2=(1<<PWM2) | (1<<COM21) | (0<<COM20) | (1<<CTC2) | (1<<CS22) | (1<<CS21) | (0<<CS20);
TCNT2=0x00;
OCR2 = flow_max; //  
delay_ms(1000);



// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(0<<OCIE2) | (1<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (1<<TOIE1) | (1<<TOIE0);

// External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Falling Edge
GICR|=(1<<INT1) | (0<<INT0);
MCUCR=(1<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
GIFR=(1<<INTF1) | (0<<INTF0);


// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=(0<<RXC) | (0<<TXC) | (0<<UDRE) | (0<<FE) | (0<<DOR) | (0<<UPE) | (0<<U2X) | (0<<MPCM);
UCSRB=(1<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (1<<RXEN) | (1<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);
UCSRC=(1<<URSEL) | (0<<UMSEL) | (0<<UPM1) | (0<<UPM0) | (0<<USBS) | (1<<UCSZ1) | (1<<UCSZ0) | (0<<UCPOL);
UBRRH=0x00;
UBRRL=0x33; // 9600



// Analog Comparator initialization
// Analog Comparator: Off
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
SFIOR=(0<<ACME);

// ADC initialization
// ADC Clock frequency: 1000,000 kHz
// ADC Voltage Reference: AREF pin
ADCSRA=(1<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);
SFIOR=(0<<ACME);





// Global enable interrupts
#asm("sei")

while (1)
  {
      // Place your code here 
        
       if(flag_100hz == 1)
         {
          //PORTC  |= (1<<PORTC0); //1        
                    
          // Timer/Counter 0 initialization
          // Clock source: System Clock
          // Clock value: 7,813 kHz
          TCCR0=(1<<CS02) | (0<<CS01) | (1<<CS00);
          TCNT0=sp;           //250 -  . 181 - 
          triac_off;       //      .
          
              
              flag_pid_on++;
           if(flag_pid_on >= 50)      //   
           {
             //  
            temper = 0; 
            ADMUX  |= (1<<MUX0); //  5
            ADMUX  &= ~(1<<MUX1); 
            ADMUX  |= (1<<MUX2);
            delay_us(10); 
            for (i = 1; i <= 3; i++)
            {                                  //     
            ADCSRA |= (1<<ADSC);      //      1
            while(!(ADCSRA & (1<<ADIF)))    //  ,   .  
            {}                            //     
            temper = temper + ADCW;           // 
            }
            temper = temper/3;
             
            
            
             // PIDr       
             error = set_temper_aver - temper;
             
             control_action = Kp*error + Ki*integral + Kd*(error - last_error);       //pidr
             last_error = error; 
              
             
              /*
                 bias = 
                 set_temper_aver  0 ...  600
                 sp           181.....210
                 
                  
                 210-181 =  29
                 (29 * set_temper_aver/500) + 181
               
             */
              
             bias = (29 * set_temper_aver/700) + 181;
               
             sp =  bias + control_action;          //195  
             if (sp<181)
             {sp = 181;}   //  
             if (sp>210)         
             {sp = 210;} //   
             
            if ((control_action > -20)&&(control_action < 20))
             {integral = integral + error;} 
             /*
             if(integral > 100)
             {integral = 100;}
             if(integral < -100)
             {integral = -100;} 
             */
             
             
             // 
              if(((set_temper_aver > last_set_temper_aver + 10)|(set_temper_aver < last_set_temper_aver - 10))&&(buzzer_flag == 2))
              {
               buzzer_flag = 0;
              }
              
             //   
             if((standby_on == 1)&&(power_on))
             {
               DDRC ^= (1<<DDC1);       // 
               DDRC ^= (1<<DDC2);
             }






              //   UART
                      send_Uart(13);					//	 
                      send_Uart_str("$");	//	      
                      send_int_Uart(temper);			//	 
                      send_Uart_str(" ");	//	 
                      send_int_Uart(set_temper_aver);			//	 
                      send_Uart_str(" ");	//	 
                      send_int_Uart(OCR2);			//	 
                      send_Uart_str(";");	//	 
              
              
              
              
              
              
              
              
              
              
             
             flag_pid_on = 0; 
           }
           
           
           flag_led_poweroff++;
           if((flag_led_poweroff >=20)&&(power_off))   // 5     ,  .
           {
               DDRC ^= (1<<DDC1);       // 
               DDRC ^= (1<<DDC2); 
               flag_led_poweron = 1;
              flag_led_poweroff = 0;
           } 
           
           if ((power_on)&&(flag_led_poweron == 1))
           {
               DDRC |= (1<<DDC1);       // ,   
               DDRC |= (1<<DDC2); 
               flag_led_poweron = 0;   //      
            
           }
             
            
             flag_flow_adj++;
             if(flag_flow_adj >= 2)             //   
             {
             // 
             if((error < 20)&&(error > -20)&&(OCR2 < flow))
             {OCR2++;}
             if((error < 20)&&(error > -20)&&(OCR2 > flow))
             {OCR2--;}
             if(error < -20)
             {OCR2 = flow_max;}
             if(error > 20)
             {OCR2 = flow_min;}
              
             if((sleep_on == 1)&&(temper < temper_min))
              {
              OCR2 = 0;
              }
              
             flag_flow_adj = 0;
             }  
             
             
             
             //     
             if((error < 10)&&(error > -10)&&(OCR2 == flow))
             {
              led_red_on;   
              led_green_on;
              if(buzzer_flag == 0)
              {buzzer_flag = 1;}   
             } 
             if(error >= 10)
             {
              led_red_off;   
              led_green_on;    
             }
             if(error <= -10)
             {
              led_green_off;   
              led_red_on;    
             }
             
             
                
             
             
             
          
             //  
              ADMUX  &= ~(1<<MUX0);      //  4
              ADMUX  &= ~(1<<MUX1);
              ADMUX  |= (1<<MUX2);
              delay_us(10);                                                    
              ADCSRA |= (1<<ADSC);      //      1
              while(!(ADCSRA & (1<<ADIF)))    //  ,   .  
              {}             //     
              set_temper = ADCW;   // 
              set_temper_adc_aver = (1 - coefLPF) * set_temper_adc_aver + set_temper * coefLPF; // 
              set_temper_aver = ((set_temper_adc_aver * (temper_max - temper_min))/1024)+temper_min;    //                   
              
              
              //  
              if(reed_switch_time >= 18025)  // 100hz * 180 = 3             
              {
               set_temper_aver = 100;
              }  
              if(reed_switch_time == 18025)
              {
               standby_on = 1;
              }
             
             
              //  
              if(reed_switch_time >= 36000)    // 6       
              {
               set_temper_aver = temper_min;
               DDRB &= ~(1<<DDB1);            //    
               reed_switch_time = 36000;      //      
                
               sleep_on = 1; 
               
              }            
             
             
             
              if(power_off)           //  
              {set_temper_aver = 0;
               
               } 
              
              
              
             
              
              
              
              
              
              
              
                              
             //   
              ADMUX  |= (1<<MUX0);      //  3
              ADMUX  |= (1<<MUX1); 
              ADMUX  &= ~(1<<MUX2);      
              delay_us(10);                                                    
              ADCSRA |= (1<<ADSC);      //      1
              while(!(ADCSRA & (1<<ADIF)))    //  ,   .  
              {}             //     
              set_flow = ADCW;   //  
              set_flow_aver = (1 - coefLPF) * set_flow_aver + set_flow * coefLPF; //  
              flow = ((set_flow_aver * (flow_max - flow_min))/1010)+flow_min;     //     
              if (flow > 255)
              {
               flow = 255;
              }
              if(standby_on == 1)
              {
               flow = flow_min;
              }
              
              
              
              
                               /*
             // 
              if(reed_switch_on)
              {
               reed_switch_time++;        //   
              }
              
              if( (power_off)|((reed_switch_off)&&(sleep_on == 0))|((sleep_on == 1)&&((flow > last_flow + 10)|(flow < last_flow - 10)))) //                  
              {
               reed_switch_time = 0;     //    
               DDRB |= (1<<DDB1);       //      
               DDRC |= (1<<DDC1);       //   
               DDRC |= (1<<DDC2);
               sleep_on = 0;
              } 
              
                               */
              
               reed_switch_time++;        //    
               
               if ((sleep_on == 1)&&((flow > last_flow + 10)|(flow < last_flow - 10))) //                  
              {
               OCR2 = flow_max; //    
               delay_ms(1000);

               reed_switch_time = 0;     //    
               DDRB |= (1<<DDB1);       //      
               DDRC |= (1<<DDC1);       //   
               DDRC |= (1<<DDC2);
               sleep_on = 2;
              } 
              
                                  //   ,       
              if (reed_switch_off)
              {
               NewState = 0;
              } 
              else
              {
               NewState = 1;
              }
                     
              
              if((NewState!=OldState)&&(sleep_on == 0))           //  
               {  
                 
                  reed_switch_time = 0;     //    
                  DDRC |= (1<<DDC1);       //   
                  DDRC |= (1<<DDC2);
                      
                   OldState=NewState;
               }
              
                       
              
              
              
              
              
              
               
              
              //    
              if((reed_switch_time == 16880)|(reed_switch_time == 17280)|(reed_switch_time == 17580)|(reed_switch_time == 17780)|(reed_switch_time == 17880))
              {
               buzzer_flag = 3;   //0,02
              }
              if(reed_switch_time == 17980)
              {
               buzzer_flag = 1;   //0,2
              }
              if((reed_switch_time == 18010)|(reed_switch_time == 18025))
              {
               buzzer_flag = 4;   //0,05
              }
              
             
              
              //    
              if(reed_switch_time == 35935)
              {
               buzzer_flag = 1;
              }
              if((reed_switch_time == 35965)|(reed_switch_time == 35980)|(reed_switch_time == 35995))
              {
               buzzer_flag = 4;   //0,05
               standby_on = 0;
               last_flow = flow;                            //   
              }
          

              //       
              if(((reed_switch_time == 0)|(reed_switch_time == 12))&&((standby_on == 1)|(sleep_on == 2)))
              {
               buzzer_flag = 3;
               if(reed_switch_time == 12)
               {
                standby_on = 0;
                sleep_on = 0;
               }
              }
           
               
              
              
              
             //  
              if(power_on)             //   
              {relay_on;}
              if((power_off)&&(temper < temper_min)) //     
              {relay_off;}  
              
              
              
              
              
              
              
              
              
             
             // 1    0,2
             if(buzzer_flag == 1)
             {
              buzzer_on;
              buzzer_time++;
              
               if(buzzer_time >= 20)
               {
                buzzer_off;
                buzzer_flag = 2;
                buzzer_time = 0;
                last_set_temper_aver = set_temper_aver; 
               }
             } 
             
             
             
             // 2    0,02
             if(buzzer_flag == 3)
             {
              buzzer_on;
              buzzer_time++;
              
               if(buzzer_time >= 2)
               {
                buzzer_off;
                buzzer_flag = 2;
                buzzer_time = 0;
               }
             }
             
             
            
             // 3    0,05
             if(buzzer_flag == 4)
             {
              buzzer_on;
              buzzer_time++;
              
               if(buzzer_time >= 5)
               {
                buzzer_off;
                buzzer_flag = 2;
                buzzer_time = 0;
               }
             }



           
              
              
             
             
             
             
             
              
             //   UART
             if(parameters_out == 1)
             {
              switch (rx_buffer[1])
               {
                case 'a':
                      flow_min = (rx_buffer[4] - 48) + ((rx_buffer[3] - 48)*10) + ((rx_buffer[2] - 48)*100) ;
                      eeflow_min = flow_min; 
                break;
                
                case 'b':
                      flow_max = (rx_buffer[4] - 48) + ((rx_buffer[3] - 48)*10) + ((rx_buffer[2] - 48)*100) ;
                      eeflow_max = flow_max; 
                break;
                
                case 'c':
                      temper_min = (rx_buffer[4] - 48) + ((rx_buffer[3] - 48)*10) + ((rx_buffer[2] - 48)*100) ;
                      eetemper_min = temper_min; 
                break;
                
                case 'd':
                      temper_max = (rx_buffer[4] - 48) + ((rx_buffer[3] - 48)*10) + ((rx_buffer[2] - 48)*100) ;
                      eetemper_max = temper_max; 
                break;
                
                case '1':
                     eeflag_primary_values = 255;  //     
                     send_Uart(13);                    //     
                     send_Uart_str("primary_values");    //     
                break;  
                
                case '0': //        
                      send_Uart(13);					//	 
                      send_Uart_str("flow_min ");	//	      
                      send_Uart_str("a");	//	  
                      send_int_Uart(flow_min);			//	 
                      send_Uart(13);					//	 
                      send_Uart_str("flow_max ");	//	      
                      send_Uart_str("b");	//	  
                      send_int_Uart(flow_max);			//	 
                      send_Uart(13);					//	 
                      send_Uart_str("temper_min ");	//	      
                      send_Uart_str("c");	//	  
                      send_int_Uart(temper_min);			//	 
                      send_Uart(13);					//	 
                      send_Uart_str("temper_max ");	//	      
                      send_Uart_str("d");	//	  
                      send_int_Uart(temper_max);			//	 
                      
                      
                       
                break;
                
               } 

              
              
              
              
              
              parameters_out = 0; 
             } 
              
              
             
                
          
          
           
          //PORTC  &= ~(1<<PORTC0); //0  
          flag_100hz = 0;//       
         } 
           
         
         
                 /*
       if (reed_switch_off)          //  
              {
               NewState = 0;
              } 
              else
              {
               NewState = 1;
              }
      
      
      
      if((NewState!=OldState)&&(sleep_on == 0))           //  
               {  
                 
                  reed_switch_time = 0;     //    
                  OldState=NewState;
               } 
               
               */  

  }
}


  
    
    // External Interrupt 1 service routine     
interrupt [EXT_INT1] void ext_int1_isr(void)
{
// Place your code here

flag_100hz = 1;        //     

}


// Timer 0 overflow interrupt service routine  
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here

   switch (flag_phase)              //     
    {
    case 0:
          triac_on;
          TCNT0=252;
          flag_phase = 1;
    break;
     
     
    case 1:
          triac_off;
          TCCR0 = 0;
          flag_phase = 0;
    break; 
     
     
    } 


}

// Timer2 overflow interrupt service routine       
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here



}


  // USART 
interrupt [USART_RXC] void usart_rx(void)
 {
  // Place your code here
  
      char status,data;
	status=UCSRA;
	data=UDR;
	if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	{
		if (data =='(')
		{
			rx_wr_index=0;
			read_enable = 1;
         
	 	}
      
		if((data == ')')&&(read_enable == 1))
		{
				read_enable = 0;
				parameters_out = 1;				
		}
      
		if (read_enable == 1)
		{
			rx_buffer[rx_wr_index++]=data;
			if (rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
         
			if (++rx_counter == RX_BUFFER_SIZE)
			{
				rx_counter=0;
				rx_buffer_overflow=1;
			}
         
		}
       
	}



 } 
 
 
 // Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Reinitialize Timer1 value
TCNT1H=0xEFFF >> 8;
TCNT1L=0xEFFF & 0xff;
// Place your code here

 //   
                 
          if((reed_switch_time >= 36000)&&(power_on))    // 6       
              {        
               
               led_pwm_off++;
               
               if((led_pwm_off >= 60)&&(led_pwm_flag == 0))
                {
                 //ledsoff;
                 DDRC &= ~(1<<DDC1);
                 DDRC &= ~(1<<DDC2);
                 led_pwm_off = 0;
                 led_pwm_on++;
                 
                } 
                
                if((led_pwm_off >= 60)&&(led_pwm_flag == 1))
                {
                 //ledsoff;
                 DDRC &= ~(1<<DDC1);
                 DDRC &= ~(1<<DDC2);
                 led_pwm_off = 0;
                 led_pwm_on--;
                 
                } 
                
                
                
                if(led_pwm_off > led_pwm_on)
                {
                 //ledson;
                 DDRC |= (1<<DDC1);
                 DDRC |= (1<<DDC2);
                }
                
                if(led_pwm_on >= 56)
                {
                 led_pwm_flag = 1;
                } 
                
                if(led_pwm_on <= 0)
                {
                 led_pwm_flag = 0;
                }
               
               }





}
